#include <iostream>
using namespace std;

struct No {
    float valor;
    No * prox;
};

struct Lista {
    No * ini;
};

void inserirInicio(Lista &lista, float dado);
void inserirFim(Lista &lista, float dado);
void imprimir(Lista lista);
void inserirOrdenadoCrescente(Lista &lista, float dado);
int removerInicio(Lista &lista, float &valor);
int removerFim(Lista &lista, float &valor);

int main(void) {

    Lista lista;

    lista.ini = NULL;
    float dado;

    do {
        cout << "Digite um numero: ";
        cin >> dado;
        if (dado > 0.0) inserirOrdenadoCrescente(lista, dado);
    } while( dado > 0.0 );

    removerInicio(lista,dado);
    removerFim(lista,dado);
    imprimir(lista);
}

void inserirFim(Lista &lista, float dado) {
    No * atual;
    // Criar o n
    No * tmp = new No;
    tmp->valor = dado;
    // O prximo do novo elemento  NULL
    tmp->prox = NULL;
    // Verificar se a lista est vazia
    atual = lista.ini;
    if (atual == NULL) {
        // Apontar o incio da lista para o novo n
        lista.ini = tmp;
    }
    else {
        // Procurar o ltimo elemento
        while (atual->prox != NULL) atual = atual->prox;
        // Apontar o gancho do ltimo elemento para o novo elemento.
        atual->prox = tmp;
    }
}

void inserirOrdenadoCrescente(Lista &lista, float dado) {
    No * atual;
    // Criar o n
    No * tmp;
    tmp = new No;
    tmp->valor = dado;
    // Procurar o elemento que antecede a posio de insero
    atual = lista.ini;
    if (atual == NULL) {
        // Lista vazia
        lista.ini = tmp;
        tmp->prox = NULL;
    } else if (atual->prox == NULL || dado <= atual->valor) {
        // Lista com apenas um n
        if (dado <= atual->valor) {
            // Inserir antes
            tmp->prox = lista.ini;
            lista.ini = tmp;
        } else {
            // Inserir depois
            tmp->prox = NULL;
            atual->prox = tmp;
        }
    } else {
        while (atual->prox != NULL &&
               atual->prox->valor <= dado) atual = atual->prox;
        // Apontar o prx do tmp para o prx do atual
        tmp->prox = atual->prox;
        // Aprox o prx do atual para o tmp
        atual->prox = tmp;
    }
}

void inserirInicio(Lista &lista, float dado) {
    // Criar um novo elemento
    No * tmp = new No;
    tmp->valor = dado;
    // Apontar o prox dele pro inicio da lista
    tmp->prox = lista.ini;
    // Apontar o inicio da lista pro novo elemento
    lista.ini = tmp;
}

void imprimir(Lista lista) {
    No * atual;
    atual = lista.ini;
    while (atual != NULL) {
        cout << atual->valor << endl;
        atual = atual->prox;
    }
}

int removerInicio(Lista &lista, float &valor) {
    No * tmp;
    if (lista.ini == NULL) return 1;
    // N a ser removido
    tmp = lista.ini;
    lista.ini = lista.ini->prox;
    valor = tmp->valor;
    delete tmp;
    return 0;
}

int removerFim(Lista &lista, float &valor) {
    No * tmp, * ultimo;
    if (lista.ini == NULL) return 1;
    tmp = lista.ini;
    if (tmp->prox == NULL) {
        // S h um elemento
        valor = tmp->valor;
        lista.ini = NULL;
        delete tmp;
    }
    else {
        while(tmp->prox->prox != NULL) tmp = tmp->prox;
        ultimo = tmp->prox;
        valor = ultimo->valor;
        tmp->prox = NULL;
        delete ultimo;
    }
    return 0;
}

int removerMeio(Lista &lista, int pos, float &valor) {
    int c = 1;
    No * atual;
    if (lista.ini == NULL) return 1;
    if (c == 1) {
        // Primeira posio
        tmp = lista.ini;
        valor = tmp->valor;
        lista.ini = tmp->prox;
        delete tmp;
    } else {
        atual = lista.ini;
        while(c < pos-1 && atual->prox != NULL) {
            atual = atual->prox;
            c++;
        }
        if (atual->prox != NULL) {
            valor = atual->prox->valor;
            tmp = atual->prox;
            atual->prox = atual->prox->prox;
            delete tmp;
        } else return 1;
    }
    return 0;
}

